/*******************************************************************************/
//  Bernard Lidicky - 1999,2000
//  Hippo Games
//  Awary
//  HraAwary.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "Awary.h"
#include "HraAwary.h"

//pridani modulu - inteligenci
#include "Modul2.h"

#include "Constants.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

const game[] = {12,11,10,9,8,7,14,5,4,3,2,1,0,14};


//******************************************************************************
// Inicializace
//******************************************************************************
CHraAwary::CHraAwary()
{
	CString s;
	int i;

	// tvorba fontu
	m_thread = NULL;

	m_font.CreateFont(20,0,0,0,FW_BOLD,0,0,0,1,OUT_DEFAULT_PRECIS, 
						   CLIP_DEFAULT_PRECIS,PROOF_QUALITY,DEFAULT_PITCH,
							"Verdena"); // Verdena - Times New Roman

		// pozadi
		m_lpDDSAll = NULL;

		m_lpDDSAll = DDLoadBitmap(ddraw,"IDB_AWP",0,0,AfxGetApp()->m_hInstance);

		if(m_lpDDSAll ==  NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);
		// kameny
		m_lpDDSKameny = NULL;

		m_lpDDSKameny = DDLoadBitmap(ddraw,"IDB_AWK",0,0,AfxGetApp()->m_hInstance);

		if(m_lpDDSKameny ==  NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);
		DDSetColorKey(m_lpDDSKameny,RGB(255,0,255)); // nastaveni barevneho klice

	
	//default init
	m_hrac[0] = 0;
	m_hrac[1] = 0;
	m_cas[0] = 0;
	m_cas[1] = 0;
	m_tah = 0;
	m_zacinal = 0;
	m_mousep = 14;

	// nacteni score z registru
	for(i = 0; i < 6; i++) {
		s.Format("level%d",i+1);
		m_level[i] = AfxGetApp()->GetProfileInt("Awary",s,0);
		if(m_level[i] < 0) m_level[i] = 0;
		if(m_level[i] > 3) m_level[i] = 3;
	}

}
//******************************************************************************
CHraAwary::~CHraAwary()
{
	int i;
	t_kill = true;

	m_font.Detach();

	// uvolneni surfacu
	if (m_lpDDSAll != NULL) {
		m_lpDDSAll->Release();
		m_lpDDSAll = NULL;
	}
	if (m_lpDDSKameny != NULL) {
		m_lpDDSKameny->Release();
		m_lpDDSKameny = NULL;
	}


	// zapsani stavu do registru
	CString s;
	for(i = 0; i < 6; i++) {
		s.Format("level%d",i+1);
		AfxGetApp()->WriteProfileInt("Awary",s,m_level[i]);
	}

}
//******************************************************************************
// Activate
void CHraAwary::Activate()
{
	m_toredraw = 0;
	m_mousep   = 14;
	ZobrazKurzor(TRUE);
}
//******************************************************************************
// Arbitraz hry
//******************************************************************************
// NovaHra
void CHraAwary::NovaHra(int pl1, int pl2, int zacina, int pozadi)
{
	m_hrac[0] = pl1;  // hrac dole
	m_hrac[1] = pl2;


		// reset hry
	int i,j;
	m_hra[14] = 0;	
	m_hra[13] = 0;	
	m_hra[6]  = 0;	
	for(i = 0; i < 6; i++) {
		m_hra[i] = 3;
		m_hra[i+7] = 3;
	}

	for(i = 0; i < 14; i++)
		for(j = 0; j < 36; j++) m_draw[i][j] = 0;
		

	Refresh();

	m_tahne = zacina;
	m_zacinal = zacina;

	m_cas[0] = 0;
	m_cas[1] = 0;

	DalsiTah(); // a jedem
}
//******************************************************************************
// Tahnul
void CHraAwary::Tahnul(int x, int kdo)
{

	if(Konec()) return; // jistota
	if(m_hrac[m_tahne] != kdo) return;
	if((x == 6) || (x == 13))  return;
	if(m_hra[x] == 0)				return;
	if(((x < 6) && (m_tahne == HRAC_NAHORE)) || 
		((x > 6) && (m_tahne == HRAC_DOLE))) return;

	// test, zda je mozno tah udelat, jinak DalsiTah
	m_cas[m_tahne] += timeGetTime() - m_t1;

	// provedeni rozkladu

	int k = m_hra[x];
	int m = x;
	
	int dum; 
	if(m < 6) dum = 6;
	else dum = 13;

	m_hra[x] = 0;

	Sleep(100);
	Refresh();

	// rozhozeni
	while (k > 0) {
		m++;
		if(m > 13) m = 0;
		m_hra[m]++;
		k--;
	Sleep(100);
	Refresh();
	}

	Sleep(80);
	Refresh();
	Sleep(80);
	Refresh();
	Sleep(80);
	Refresh();
	Sleep(80);
	Refresh();

	// posledni kamen
	if((m_hra[m] == 1)&&(m_hra[game[m]] != 0)) {
		m_hra[m] = 0;
		m_hra[dum] += 1 + m_hra[game[m]];
		m_hra[game[m]] = 0;
	}
	Sleep(80);
	Refresh();
	
	//zmna hrace
	if(m != dum)
		if(m_tahne == HRAC_DOLE) m_tahne = HRAC_NAHORE;
		else m_tahne = HRAC_DOLE;

	
	DalsiTah(); // hrac pravdepodobne kliknul vedle
}
//******************************************************************************
// DalsiTah
void CHraAwary::DalsiTah()
{
	if(Konec()) return; // jistota

	m_t1 = timeGetTime();
	// spsteni threadu
	if(m_hrac[m_tahne] != CLOVEK) { // hraje pocitac

		// spusteni treadu
		m_rand = rand();

		m_thread = AfxBeginThread(m2_t_Tahni,this,THREAD_PRIORITY_NORMAL);
	}
}
//******************************************************************************
// Messages
//******************************************************************************
// OnTimer
BOOL CHraAwary::OnTimer()
{
	if(!Konec()) {
		// update casu
		m_cas[m_tahne] += timeGetTime() - m_t1;
		m_t1 = timeGetTime();
	}

	if(--m_toredraw  > 0) return FALSE;

	m_toredraw = 2;

	if(Draw() == FALSE) m_toredraw = 0;

	return TRUE;
}
//******************************************************************************
// OnKeyDown
void CHraAwary::OnKeyDown(UINT nChar)
{
	switch(nChar) {
	case VK_ESCAPE :
		Done();
		break;
	default :
		if(Konec()) Done();
		break;
	}
}
//******************************************************************************
// OnLButtonDown
void CHraAwary::OnLButtonDown(CPoint point)
{

}
//******************************************************************************
// OnMouseMove
void CHraAwary::OnMouseMove(CPoint point)
{
	m_mousep = 14;
	for(int i = 0; i < 14; i++) 
		if((point.x > mys[i][0]) && (point.x < mys[i][2]) &&
			(point.y > mys[i][1]) && (point.y < mys[i][3]))  m_mousep = i;
}
//******************************************************************************
// OnLButtonUp
void CHraAwary::OnLButtonUp(CPoint point)
{
	if(m_hrac[m_tahne] != CLOVEK) return;

	for(int i = 0; i < 14; i++) 
		if((point.x > mys[i][0]) && (point.x < mys[i][2]) &&
			(point.y > mys[i][1]) && (point.y < mys[i][3])) {
			Tahnul(i, CLOVEK);
			return ;
		}
}
//******************************************************************************
// Diagnostika hry
//******************************************************************************
// Konec
bool CHraAwary::Konec()
{
	bool konec;
		// reset hry
	int i;

	konec = true;
	for(i = 0; i < 6; i++)
		if(m_hra[i] != 0) konec = false;

	if(konec) {
		TestNextLevel();
		return true;
	}

	konec = true;
	for(i = 7; i < 13; i++)
		if(m_hra[i] != 0) konec = false;

	if(konec) TestNextLevel();

	return konec;
}
//******************************************************************************
// Grafika 
//******************************************************************************
// Draw
BOOL CHraAwary::Draw()
{

	HRESULT hres;
	int i, j;

	// placneme pozadi / hraci plochu
	hres = ddraw.m_lpDDSBack->BltFast(0,0,m_lpDDSAll,&CRect(0,0,640,480),DDBLTFAST_NOCOLORKEY | DDBLTFAST_WAIT);
	if(hres == DDERR_SURFACELOST) {
		Restore();
		return FALSE;
	}

	// vyplneni hraci plochy kameny
	int x,y;

	for(i = 0; i < 14; i++)
		for(j = 0; j < 36 ; j++) {
			if(m_draw[i][j] == 0) break;
			if((i == 6) || (i == 13)) { // domecek
				x = domek[j][0] + mapa[i][0] - 10;
				y = domek[j][1] + mapa[i][1] - 10;
			}
			else {
				if (j > 17) break;
				x = plicko[j][0] + mapa[i][0] - 10;
				y = plicko[j][1] + mapa[i][1] - 10;
			}
			hres = ddraw.m_lpDDSBack->BltFast(x,y,m_lpDDSKameny,&CRect(m_draw[i][j]*21,0,m_draw[i][j]*21+20,20),DDBLTFAST_SRCCOLORKEY | DDBLTFAST_WAIT);
			if(hres == DDERR_SURFACELOST) {
				Restore();
				return FALSE;
			}
		}
// update hraci plochy
	for(i = 0; i < 14; i++)
		for(j = 0; j < 36; j++) {
			if((m_hra[i] >  j) && (m_draw[i][j] < MAX_ANIM)) m_draw[i][j]++;
			if((m_hra[i] <= j) && (m_draw[i][j] > 0)) m_draw[i][j]--;
		}

	// psani 
		// napsani score
	CString s;
	CDC *dc;
	dc = CDC::FromHandle(ddraw.GetBackDC());
	dc->SetBkMode(TRANSPARENT);
	dc->SetTextColor(RGB(255,255,200));

	CFont *old = dc->SelectObject(&m_font);

	dc->SetTextColor(RGB(255,255,0));

	// napsani casu
	s.Format("%d s",m_cas[1]/1000);
	dc->DrawText(s,CRect( 76,382,107,404),DT_CENTER|DT_VCENTER);

	s.Format("%d s",m_cas[0]/1000);
	dc->DrawText(s,CRect(524,381,556,404),DT_CENTER|DT_VCENTER);

	// napsani bodu
	s.Format("%d",m_hra[13]);
	dc->DrawText(s,CRect( 80, 90,104,111),DT_CENTER|DT_VCENTER);

	s.Format("%d",m_hra[6]);
	dc->DrawText(s,CRect(526, 90,553,111),DT_CENTER|DT_VCENTER);

	if(m_mousep != 14) {
		s.Format("%d",m_hra[m_mousep]);
		dc->DrawText(s,CRect(293,452,317,472),DT_CENTER|DT_VCENTER);
	}

	// uklid
	dc->SelectObject(old);
	ddraw.ReleaseBackDC();



	return TRUE;
}
//******************************************************************************
// Restore
void CHraAwary::Restore()
{
	m_lpDDSAll->Restore();
	DDReLoadBitmap(m_lpDDSAll,"IDB_AWP",AfxGetApp()->m_hInstance);

		// kameny
	m_lpDDSKameny->Restore();
	DDReLoadBitmap(m_lpDDSKameny,"IDB_AWK",AfxGetApp()->m_hInstance);
	DDSetColorKey(m_lpDDSKameny,RGB(255,0,255)); // nastaveni barevneho klice
}

//******************************************************************************
void CHraAwary::LockBuffers()
{
}
//******************************************************************************
void CHraAwary::UnlockBuffers()
{
}
//******************************************************************************
void CHraAwary::Done()
{
	t_kill = true;

	AfxGetApp()->m_pMainWnd->SendMessage(WM_MENU,0,0);
}
//******************************************************************************
void CHraAwary::Refresh()
{
	if(stav_hry != AWARY) return;

	Draw();
	ddraw.Flip();
}
//******************************************************************************
void CHraAwary::TestNextLevel()
{
	if((m_hrac[0] == CLOVEK) && (m_hrac[1] == CLOVEK)) return;
	// pocitani score
	int ja,on;
	if(m_hrac[0] == CLOVEK) { ja = 0; on = 1; }
	else { ja = 1; on = 0;}

	if(m_hra[ja*7+6] > m_hra[on*7+6])
		if(m_zacinal == ja) A_PLDONE(m_level[m_hrac[on]-1]);
		else A_CPDONE(m_level[m_hrac[on]-1]);
	
}

