/*******************************************************************************/
//  Bernard Lidicky - 1999,2000
//  Hippo Games
//  Awary
//  HraOthello.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "Awary.h"
#include "HraOthello.h"

//pridani modulu - inteligence
#include "Modul1.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//******************************************************************************
// Inicializace
//******************************************************************************
CHraOthello::CHraOthello()
{
	int i;
	CString s;
	// tvorba fontu
	m_thread = NULL;

	m_font.CreateFont(40,0,0,0,FW_BOLD,0,0,0,1,OUT_DEFAULT_PRECIS, 
						   CLIP_DEFAULT_PRECIS,PROOF_QUALITY,DEFAULT_PITCH,
							"Verdena"); // Verdena - Times New Roman

	m_fonts.CreateFont(20,0,0,0,FW_BOLD,0,0,0,1,OUT_DEFAULT_PRECIS, 
						   CLIP_DEFAULT_PRECIS,PROOF_QUALITY,DEFAULT_PITCH,
							"Verdena"); // Verdena - Times New Roman

		// pozadi
		m_lpDDSAll = NULL;
		m_lpDDSAll = DDLoadBitmap(ddraw,"IDB_OTP",0,0,AfxGetApp()->m_hInstance);
		if(m_lpDDSAll ==  NULL) AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);
		// kameny
		m_lpDDSKameny = NULL;
		m_lpDDSKameny = DDLoadBitmap(ddraw,"IDB_OTK",0,0,AfxGetApp()->m_hInstance);
		if(m_lpDDSKameny ==  NULL) {
			AfxGetApp()->m_pMainWnd->SendMessage(WM_QUIT);
			return;
		}
		DDSetColorKey(m_lpDDSKameny,RGB(255,0,255)); // nastaveni barevneho klice

	
	//default init
	m_hrac[0] = 0;
	m_hrac[1] = 0;
	m_cas[0] = 0;
	m_cas[1] = 0;
	m_score[0] = 0;
	m_score[1] = 0;
	m_tah = 0;
	m_zacinal = NIC;

	// nacteni score z registru
	for(i = 0; i < 6; i++) {
		s.Format("level%d",i+1);
		m_level[i] = AfxGetApp()->GetProfileInt("Othello",s,0);
		if(m_level[i] < 0) m_level[i] = 0;
		if(m_level[i] > 3) m_level[i] = 3;
	}


}
//******************************************************************************
CHraOthello::~CHraOthello()
{
	int i;

	t_kill = true;

	// uvolneni surfacu
	if (m_lpDDSAll != NULL) {
		m_lpDDSAll->Release();
		m_lpDDSAll = NULL;
	}
	if (m_lpDDSKameny != NULL) {
		m_lpDDSKameny->Release();
		m_lpDDSKameny = NULL;
	}


	// zapsani stavu do registru
	CString s;
	for(i = 0; i < 6; i++) {
		s.Format("level%d",i+1);
		AfxGetApp()->WriteProfileInt("Othello",s,m_level[i]);
	}
}
//******************************************************************************
// Activate
void CHraOthello::Activate()
{
	m_toredraw = 0;
	ZobrazKurzor(TRUE);
}
//******************************************************************************
// Arbitraz hry
//******************************************************************************
// NovaHra
void CHraOthello::NovaHra(int pl1, int pl2, int zacina, int pozadi)
{
	m_hrac[0] = pl1;  // hrac dole
	m_hrac[1] = pl2;


		// reset hry
	int i,j;

	// resetovani hraci plochy
	for(i = 0; i < 8; i++)
		for(j = 0; j < 8; j++) m_hra[i][j] = NIC;
	m_hra[3][3] = BILY;
	m_hra[4][4] = BILY;
	m_hra[4][3] = CERNY;
	m_hra[3][4] = CERNY;
	m_draw[3][3] = NIC_BILY;
	m_draw[4][4] = NIC_BILY;
	m_draw[4][3] = NIC_CERNY;
	m_draw[3][4] = NIC_CERNY;
		
	m_score[0] = 2;
	m_score[1] = 2;

	Refresh();

	m_tahne = zacina;
	m_zacinal = zacina;

	m_cas[0] = 0;
	m_cas[1] = 0;

	DalsiTah(); // a jedem
}
//******************************************************************************
// Tahnul
void CHraOthello::Tahnul(int x, int y, int kdo)
{
	if(Konec()) return; // jistota
	if(m_hrac[m_tahne] != kdo) return;
	if(!LzeTah(x,y,m_tahne))		return;
	// test, zda je mozno tah udelat, jinak DalsiTah
	m_cas[m_tahne] += timeGetTime() - m_t1;
	
	// provedeni rozkladu

	UdelejTah(x,y,m_tahne);

	UpdateScore();

	// animacka
	Sleep(80);
	Refresh();
	Sleep(80);
	Refresh();
	Sleep(80);
	Refresh();
	Sleep(80);
	Refresh();

	if(Konec()) return;

	//zmena hrace
	if(m_tahne == HRAC_BILY){
		if(MuzeHrat(HRAC_CERNY)) m_tahne = HRAC_CERNY;
	}
	else {
		if(MuzeHrat(HRAC_BILY)) m_tahne = HRAC_BILY;
	}

	DalsiTah(); // hrac pravdepodobne kliknul vedle
}
//******************************************************************************
// DalsiTah
void CHraOthello::DalsiTah()
{
	if(Konec()) return; // jistota

	m_t1 = timeGetTime();
	// spsteni threadu
	if(m_hrac[m_tahne] != CLOVEK) { // hraje pocitac

		// spusteni treadu
		m_rand = rand();
		m_thread = AfxBeginThread(m1_t_Tahni,this,THREAD_PRIORITY_NORMAL);
	}
}
//******************************************************************************
// Messages
//******************************************************************************
// OnTimer
BOOL CHraOthello::OnTimer()
{
	if(!Konec()) {
		// update casu
		m_cas[m_tahne] += timeGetTime() - m_t1;
		m_t1 = timeGetTime();
	}

	if(--m_toredraw  > 0) return FALSE;

	m_toredraw = 2;

	if(Draw() == FALSE) m_toredraw = 0;

	return TRUE;
}
//******************************************************************************
// OnKeyDown
void CHraOthello::OnKeyDown(UINT nChar)
{
	switch(nChar) {
	case VK_ESCAPE :
		Done();
		break;
	default :
		if(Konec()) Done();
		break;
	}
}
//******************************************************************************
// OnLButtonDown
void CHraOthello::OnLButtonDown(CPoint point)
{

}
//******************************************************************************
// OnMouseMove
void CHraOthello::OnMouseMove(CPoint point)
{

}
//******************************************************************************
// OnLButtonUp
void CHraOthello::OnLButtonUp(CPoint point)
{
	if(m_hrac[m_tahne] != CLOVEK) return;
	// hrac klepl do plochy
	if(point.x > 100 && point.x < 524 && 
		point.y >  25 && point.y < 449 ) {
		Tahnul((point.x - 100) / 53, (point.y - 25) / 53, CLOVEK);
	}
}
//******************************************************************************
// Diagnostika hry
//******************************************************************************
// Konec
bool CHraOthello::Konec()
{
	int i,j;

	for(i = 0; i < 8; i++)
		for(j = 0; j < 8; j++){
			if(LzeTah(i,j,HRAC_BILY )) return false;
			if(LzeTah(i,j,HRAC_CERNY)) return false;
		}

	TestNextLevel();
	return true;
}
//******************************************************************************
// Grafika 
//******************************************************************************
// Draw
BOOL CHraOthello::Draw()
{

	HRESULT hres;
	int i, j;

	// placneme pozadi / hraci plochu
	hres = ddraw.m_lpDDSBack->BltFast(0,0,m_lpDDSAll,&CRect(0,0,640,480),DDBLTFAST_NOCOLORKEY | DDBLTFAST_WAIT);
	if(hres == DDERR_SURFACELOST) {
		Restore();
		return FALSE;
	}

	// vyplneni hraci plochy kameny
	for(i = 0; i < 8; i++)
		for(j = 0; j < 8 ; j++) {
			if(m_hra[i][j] == NIC) continue;
			hres = ddraw.m_lpDDSBack->BltFast((i * 53 + 100 + 7), (j * 53 + 25 + 7), m_lpDDSKameny,
					 &CRect(m_draw[i][j].x*41,m_draw[i][j].y*41,m_draw[i][j].x*41+40,m_draw[i][j].y*41+40),DDBLTFAST_SRCCOLORKEY | DDBLTFAST_WAIT);
			if(hres == DDERR_SURFACELOST) {
				Restore();
				return FALSE;
			}
			// posun animace
			if(m_draw[i][j].x < 5) m_draw[i][j].x++;
		}

	// napsani score
	CString s;
	CDC *dc;
	dc = CDC::FromHandle(ddraw.GetBackDC());
	dc->SetBkMode(TRANSPARENT);
	dc->SetTextColor(RGB(255,255,200));

	// napsani score
	CFont *old = dc->SelectObject(&m_font);

	dc->SetTextColor(RGB(255,255,255));
	s.Format("%d",m_score[0]);
	dc->DrawText(s,CRect(10 ,215,70 ,265),DT_CENTER|DT_VCENTER);

	dc->SetTextColor(RGB(0,0,0));
	s.Format("%d",m_score[1]);
	dc->DrawText(s,CRect(570,215,630,265),DT_CENTER|DT_VCENTER);

	// napsani casu
	dc->SelectObject(&m_fonts);

	dc->SetTextColor(RGB(255,255,255));
	s.Format("%d s",m_cas[0]/1000);
	dc->DrawText(s,CRect(20 ,295,60 ,315),DT_CENTER|DT_VCENTER);


	dc->SetTextColor(RGB(0,0,0));
	s.Format("%d s",m_cas[1]/1000);
	dc->DrawText(s,CRect(580,295,620,315),DT_CENTER|DT_VCENTER);

	// uklid
	dc->SelectObject(old);
	ddraw.ReleaseBackDC();



	return TRUE;
}
//******************************************************************************
// Restore
void CHraOthello::Restore()
{
	m_lpDDSAll->Restore();
	DDReLoadBitmap(m_lpDDSAll,"IDB_OTP",AfxGetApp()->m_hInstance);

	// kameny
	m_lpDDSKameny->Restore();
	DDReLoadBitmap(m_lpDDSKameny,"IDB_OTK",AfxGetApp()->m_hInstance);
	DDSetColorKey(m_lpDDSKameny,RGB(255,0,255)); // nastaveni barevneho klice
}

//******************************************************************************
void CHraOthello::LockBuffers()
{
}
//******************************************************************************
void CHraOthello::UnlockBuffers()
{
}
//******************************************************************************
void CHraOthello::Done()
{
	t_kill = true;

	AfxGetApp()->m_pMainWnd->SendMessage(WM_MENU,0,0);
}
//******************************************************************************
void CHraOthello::Refresh()
{
	if(stav_hry != OTHELLO) return;

	Draw();
	ddraw.Flip();
}
//******************************************************************************
bool CHraOthello::LzeTah(int x, int y, int kdo)
{
	if(m_hra[x][y] != NIC) return false;
	
	int ja,on;
	
	if(kdo == HRAC_BILY) {
		ja = BILY; on = CERNY;
	}
	else {
		ja = CERNY; on = BILY;
	}
	if (LzeTahSmerem(x,y,-1,-1,ja,on)) return true;
	if (LzeTahSmerem(x,y,-1, 1,ja,on)) return true;
	if (LzeTahSmerem(x,y,-1, 0,ja,on)) return true;
	if (LzeTahSmerem(x,y, 0,-1,ja,on)) return true;
	if (LzeTahSmerem(x,y, 0, 1,ja,on)) return true;
	if (LzeTahSmerem(x,y, 1,-1,ja,on)) return true;
	if (LzeTahSmerem(x,y, 1, 0,ja,on)) return true;
	if (LzeTahSmerem(x,y, 1, 1,ja,on)) return true;

	return false;

}
//******************************************************************************
bool CHraOthello::LzeTahSmerem(int x, int y, int dx, int dy, int ja, int on)
{
	x += dx;
	y += dy;
	if(x < 0 || y < 0 || x > 7 || y > 7) return false;
	if(m_hra[x][y] != on) return false;
	while(m_hra[x][y] != ja) {
		x += dx;
		y += dy;
		if(x < 0 || y < 0 || x > 7 || y > 7) return false;
		if(m_hra[x][y] == NIC) return false;
	}

	return true;
}

//******************************************************************************
//******************************************************************************
void CHraOthello::UdelejTah(int x, int y, int ja)
{
	int on;
	CPoint pt;
	if(ja == BILY) {
		on = CERNY;
		m_draw[x][y] = NIC_BILY;
		m_hra[x][y]  = BILY;
		pt = CERNY_BILY;
	}
	else {
		on = BILY;
		m_draw[x][y] = NIC_CERNY;
		m_hra[x][y]  = CERNY;
		pt = BILY_CERNY;
	}

	TahSmerem(x,y,-1,-1,ja,on,pt);
	TahSmerem(x,y,-1, 1,ja,on,pt);
	TahSmerem(x,y,-1, 0,ja,on,pt);
	TahSmerem(x,y, 0,-1,ja,on,pt);
	TahSmerem(x,y, 0, 1,ja,on,pt);
	TahSmerem(x,y, 1,-1,ja,on,pt);
	TahSmerem(x,y, 1, 0,ja,on,pt);
	TahSmerem(x,y, 1, 1,ja,on,pt);
}
//******************************************************************************
void CHraOthello::TahSmerem(int x, int y, int dx, int dy, int ja, int on, CPoint pt)
{
	if(!LzeTahSmerem(x,y,dx,dy,ja,on))
		return;

	x += dx;
	y += dy;
	while(m_hra[x][y] != ja) {
		m_hra[x][y]  = ja;
		m_draw[x][y] = pt;
		x += dx;
		y += dy;
	}
}
//******************************************************************************
bool CHraOthello::MuzeHrat(int hrac)
{
	int i,j;

	for(i = 0; i < 8; i++)
		for(j = 0; j < 8; j++){
			if(LzeTah(i,j,hrac )) return true;
		}

	return false;
}
//******************************************************************************
void CHraOthello::TestNextLevel()
{
	// neni treba testovat dalsi level
	if((m_hrac[0] == CLOVEK) && (m_hrac[1] == CLOVEK)) return;

	// pocitani score
	int ja; // ja = clovek
	int on; // on = pocitac

	if(m_hrac[0] == CLOVEK) { ja = 0; on = 1; }
	else { ja = 1; on = 0;}

	UpdateScore();

	if(m_score[ja] > m_score[on])
		if(m_zacinal == ja) O_PLDONE(m_level[m_hrac[on]-1]);
		else O_CPDONE(m_level[m_hrac[on]-1]);
}
//******************************************************************************
void CHraOthello::UpdateScore()
{
	m_score[0] = m_score[1] = 0;
	for(int i = 0; i < 8; i++)
		for(int j = 0; j < 8; j++)
			if(m_hra[i][j] < 2) m_score[m_hra[i][j]]++;
}

