/*******************************************************************************/
//  Bernard Lidicky - 1999
//  CHraOthello class - Include
/*******************************************************************************/

#if !defined(AFX_HRAOTHELLO_H__F8540B61_C458_11D3_8F75_E2933529E020__INCLUDED_)
#define AFX_HRAOTHELLO_H__F8540B61_C458_11D3_8F75_E2933529E020__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#define HRAC_BILY   0
#define HRAC_CERNY  1

// othello 
#define NIC    2
#define BILY   0
#define CERNY  1

// pro kresleni
#define NIC_BILY     CPoint(0,0)
#define NIC_CERNY    CPoint(0,1)
#define CERNY_BILY   CPoint(0,2)
#define BILY_CERNY   CPoint(0,3)

#define CLOVEK 0

#define MAX_PLAYGROUNDS  1

#define MAX_ANIM  5


// o hraci - jak je na tom
#define O_CPDONE(x)  ((x) |= 0x00000001)
#define O_PLDONE(x)  ((x) |= 0x00000002)
#define O_CPVSPL(x)  ((x) &  0x00000001)
#define O_PLVSCP(x)  ((x) &  0x00000002)

class CHraOthello : public Base  
{
public:
	CHraOthello(); // konstruktor
	virtual ~CHraOthello(); // destrukktor
public:
	void UpdateScore();
	void TestNextLevel();
	bool MuzeHrat(int hrac);
	bool LzeTahSmerem(int x, int y, int dx, int dy, int ja, int on);
	bool LzeTah(int x, int y, int kdo); // za kdo se dava HRAC_CERNY/ HRAC_BILY
	void Refresh();
	void UnlockBuffers();
	void LockBuffers();
	void DalsiTah();
	void Activate(); // oznamuje, ze se hra stala aktivni
	BOOL Draw();     // vykresli aktualinni stav do back surface
	bool Konec(); // vrati, zda nekdo vyhral
	void NovaHra(int pl1, int pl2, int zacina, int pozadi); // inicializuje novou hru
	void OnKeyDown(UINT nChar);       // uzivatel neco stiskl
	void OnLButtonDown(CPoint point); // zprava mysi
	void OnLButtonUp(CPoint point);   // zprava mysi
	void OnMouseMove(CPoint point);   // zprava mysi
	BOOL OnTimer();  // odezva hlavniho timeru ( 40 ms )
	void Restore();  // pri ztrate surfacu
	void Tahnul(int x, int y, int kdo); // kam tahnul nas hrac ?

	void Done();
	// bitmapy
	LPDIRECTDRAWSURFACE     m_lpDDSAll;      // pozadi

	LPDIRECTDRAWSURFACE     m_lpDDSKameny;    // hraci kameny
	
	CFont m_font;   // hlavni font
	CFont m_fonts;  // maly font

	CWinThread *m_thread; // drzime si ukazatel
	int   m_t1; // stratovni cas jednoho tahu

	int    m_toredraw;
	CPoint m_plr;  // mys hrace 
 
	int  m_tah;    // cilso tahu
	int  m_tahne;     //  0 / 1 (HRAC_DOLE / HRAC_NAHORE,...)  
	int  m_hrac[2];  // kdo hraje // obtiznost
	int  m_cas[2];    // jak dlouho
	int  m_score[2];  // pocita, kollik kdo ma svych kamenu na sachovnici

	int  m_zacinal;

	int  m_rand;

	// othello 
	int     m_hra[8][8];   // ploch hry
	CPoint  m_draw[8][8];  // animace

	int  m_level[6];  // splneni jednotlivych obtiznosti v othellu



protected:
	void TahSmerem(int x, int y, int dx, int dy, int ja, int on, CPoint pt);
	void UdelejTah(int x, int y, int ja);
};

// threads communications
extern bool t_kill;
extern bool t_hotovo;
extern bool t_running;

#endif // !defined(AFX_HRAOTHELLO_H__F8540B61_C458_11D3_8F75_E2933529E020__INCLUDED_)
