/*******************************************************************************/
//  Bernard Lidicky - 1999, 2000
//  Hippo Games
//  Awary
//  MainFrm.cpp
/*******************************************************************************/

#include "stdafx.h"
#include "Awary.h"

#include "bbuttonek.h"
//"winerror.h"
#include "MainFrm.h"

#include "AboutBox.h"

//******************************************************************************
IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_PAINT()
	ON_WM_KEYDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	ON_WM_KEYUP()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_WM_CLOSE()
	ON_WM_SETCURSOR()
	ON_WM_SYSCOMMAND()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_INITED,Init)
	ON_MESSAGE(WM_MENU,WmMenu)
	ON_MESSAGE(WM_HRA,WmHra)
END_MESSAGE_MAP()

//******************************************************************************
CMainFrame::CMainFrame()
{
	Create(NULL,"Awary",WS_POPUP|WS_SYSMENU);

	m_icon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	SetIcon(m_icon,TRUE);
	SetIcon(m_icon,FALSE);

	
	m_cursor = AfxGetApp()->LoadCursor(IDC_SIPKA);

	if(m_cursor == NULL) {
		TRACE("Load cursor failed!! %d\n",GetLastError());
		m_cursor = LoadCursor(NULL,IDC_ARROW);
	}
	SetCursor(m_cursor);


	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	// Add "About..." menu item to system menu.
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu = "O hre";
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}


	m_uTimerID = SetTimer(5,40,NULL);

	m_menu       = NULL;
	m_hraAwary   = NULL;
	m_hraOthello = NULL;
	m_pactual    = NULL;
}
//******************************************************************************
CMainFrame::~CMainFrame()
{
//	KillTimer(m_uTimerID);
	
	m_pactual = NULL;
	if(m_menu)        delete m_menu;
	if(m_hraOthello)  delete m_hraOthello;
	if(m_hraAwary)    delete m_hraAwary;
}
//******************************************************************************
void CMainFrame::Init(int parama, int paramb)
{
	SetCursor(m_cursor);
	ZobrazKurzor(FALSE);
	// loadingovani

	// + nacteni
	m_hraAwary   = new CHraAwary;
	m_hraOthello = new CHraOthello;

	m_menu = new CMMenu;
	WmMenu(0,0);
	SendMessage(WM_TIMER);
}

//******************************************************************************
BOOL CMainFrame::RestoreAll()
{

	// zniceni ramecku okolo
	CRect Rect;
	SetRect(&Rect, 0, GetSystemMetrics(SM_CYCAPTION), GetSystemMetrics(SM_CXSCREEN), GetSystemMetrics(SM_CYSCREEN));
	AdjustWindowRectEx(&Rect, WS_POPUP | WS_CAPTION, FALSE, 0);
	SetWindowPos(NULL, Rect.left, Rect.top, Rect.right-Rect.left, Rect.bottom-Rect.top, SWP_NOACTIVATE | SWP_NOZORDER);


	return TRUE;
}
//******************************************************************************
void CMainFrame::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

}
//******************************************************************************
void CMainFrame::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	m_pactual->OnKeyDown(nChar);

	CFrameWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}
//******************************************************************************
void CMainFrame::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CFrameWnd::OnLButtonDblClk(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnLButtonDown(UINT nFlags, CPoint point) 
{
	m_pactual->OnLButtonDown(point);
	
	CFrameWnd::OnLButtonDown(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_pactual->OnLButtonUp(point);
	CFrameWnd::OnLButtonUp(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnMouseMove(UINT nFlags, CPoint point) 
{
	m_pactual->OnMouseMove(point);
	CFrameWnd::OnMouseMove(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnTimer(UINT nIDEvent) 
{
	CFrameWnd::OnTimer(nIDEvent);
	if(m_pactual == NULL) return;
	if(!IsIconic()) {
		if(m_pactual->OnTimer() == TRUE)
			ddraw.Flip();
	}

}
//******************************************************************************
void CMainFrame::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	m_pactual->OnKeyUp(nChar);
	CFrameWnd::OnKeyUp(nChar, nRepCnt, nFlags);
}
//******************************************************************************
void CMainFrame::WmMenu(int parama, int paramb)
{
 
	m_menu->Activate(m_hraAwary, m_hraOthello);
	m_pactual = m_menu;
	stav_hry  = MENU;
}
//******************************************************************************
void CMainFrame::WmHra(int parama, int paramb)
{
	// navazani spojeni

	switch(parama) {
	case AWARY :
		m_hraAwary->Activate();
		m_pactual = m_hraAwary;
		stav_hry  = AWARY;
		break;
	case OTHELLO :
		m_hraOthello->Activate();
		m_pactual = m_hraOthello;
		stav_hry  = OTHELLO;
		break;
	}
	
	m_pactual->OnTimer();

}
//******************************************************************************
void CMainFrame::WmRestore(int parama, int b)
{
	RestoreAll();
}
//******************************************************************************
void CMainFrame::OnRButtonDown(UINT nFlags, CPoint point) 
{
	m_pactual->OnRButtonDown(point);
	CFrameWnd::OnRButtonDown(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnRButtonUp(UINT nFlags, CPoint point) 
{
	m_pactual->OnRButtonUp(point);
	CFrameWnd::OnRButtonUp(nFlags, point);
}
//******************************************************************************
void CMainFrame::OnClose() 
{
	ZobrazKurzor(FALSE);
	CFrameWnd::OnClose();
}
//******************************************************************************
BOOL CMainFrame::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message) 
{
	SetCursor(m_cursor);
	return TRUE;
}
//******************************************************************************
void CMainFrame::OnSysCommand(UINT nID, LPARAM lParam)
{
	if (nID  == IDM_ABOUTBOX)
	{
		CAboutBox dlg;
		dlg.DoModal();
	}
	else {
		CFrameWnd::OnSysCommand(nID, lParam);
	}
}
