/*******************************************************************************/
//  Bernard Lidicky - 2000
//  Hippo Games
//  Awary
//  Modul1.cpp - inteligence Othello (reversi)
/*******************************************************************************/

#include "stdafx.h"
#include "Awary.h"
#include "HraOthello.h"
#include "modul1.h"

/*
casova slozitost velice zavisi na poctu dalsich moznych tahu
*/

#define M1_MAX  1000  // maximum na body -  cislo neni dulezite, al emusi byt dostatecne vysoke
/*
// matice na obodovani
const m1_body[8][8] = { 
	{5,3,3,3,3,3,3,5},
	{3,1,1,1,1,1,1,3},
	{3,1,2,2,2,2,1,3},
	{3,1,2,1,1,2,1,3},
	{3,1,2,1,1,2,1,3},
	{3,1,2,2,2,2,1,3},
	{3,1,1,1,1,1,1,3},
	{5,3,3,3,3,3,3,5},
};
*/
// matice na obodovani
const m1_body[8][8] = { 
	{5,1,3,3,3,3,1,5},
	{1,1,1,1,1,1,1,1},
	{3,1,2,2,2,2,1,3},
	{3,1,2,1,1,2,1,3},
	{3,1,2,1,1,2,1,3},
	{3,1,2,2,2,2,1,3},
	{1,1,1,1,1,1,1,1},
	{5,1,3,3,3,3,1,5},
};

/*
// matice na obodovani
const m1_body[8][8] = { 
	{6,1,4,4,4,4,1,6},
	{1,1,1,1,1,1,1,1},
	{4,1,4,3,3,4,1,4},
	{4,1,3,2,2,3,1,4},
	{4,1,3,2,2,3,1,4},
	{4,1,4,3,3,4,1,4},
	{1,1,1,1,1,1,1,1},
	{6,1,4,4,4,4,1,6},
};
*/

int m1_test[8][8];

typedef struct {
	int  tahne; // pri zanorovani
	int  ja;    // pro vyber moznosti
	int  x;     // moznost
	int  y;
} st_m1_uzel;


int m1_tested;

int m1_Testuj(st_m1_uzel moznost, int hloubka);
int m1_Symuluj(int x, int y, int *hrac);

bool m1_LzeTah(int x, int y, int kdo);
bool m1_Konec();
bool m1_MuzeHrat(int hrac);
void m1_TahSmerem(int x, int y, int dx, int dy, int ja, int on, int *p);
int  m1_UdelejTah(int x, int y, int ja);
bool m1_LzeTahSmerem(int x, int y, int dx, int dy, int ja, int on);


//******************************************************************************
// m1_t_Tahni
UINT m1_t_Tahni(LPVOID p_hra){

	int time = timeGetTime();

	t_kill = false;
	t_hotovo = false;
	t_running = true;

	CHraOthello *h = (CHraOthello*) p_hra;
	if(h->Konec()) return 0;
	srand(h->m_rand);
	// myslici proces

	// myslici proces
	int hloubka;
	switch(h->m_hrac[h->m_tahne]){
		case 1 : hloubka =  1; break;
		case 2 : hloubka =  2; break;
		case 3 : hloubka =  3; break;
		case 4 : hloubka =  5; break;
		case 5 : hloubka =  7; break;
		case 6 : hloubka =  8; break;
		default : hloubka = 2;
	}

	
	st_m1_uzel  uzel;

	uzel.ja = uzel.tahne = h->m_tahne;
	
	int j;

	st_m1_uzel max;
	int  maxi = -64;
	
	m1_tested = 0;


	for(uzel.x = 0; uzel.x < 8; uzel.x++)
		for(uzel.y = 0; uzel.y < 8; uzel.y++) {

			if(t_kill == true) return 0;


		memcpy(m1_test,h->m_hra,sizeof(int) * 64);

		if(!m1_LzeTah(uzel.x,uzel.y,uzel.tahne)) continue; // aby jsme se zbytecne nezdrzovali


		j = m1_Testuj(uzel,hloubka);

		if(j > maxi) {
			max  = uzel;
			maxi = j;
		}
		else if((j == maxi) && (Nahoda(2) == 1)) {
			max  = uzel;
			maxi = j;
		}

	}

	time = timeGetTime() - time;

	TRACE("Hloubka %d -> testovano %d tahu za %d ms\n",hloubka,m1_tested,time);

	// aby pocitac premyslel alespon 1 sekundu
	if(time < 1000) Sleep(1000 - time);

	// navrat
	h->Tahnul(max.x,max.y,h->m_hrac[h->m_tahne]);

	t_running = false;
	h->m_thread = NULL;
	return 0;
}

/*******************************************************************************/

int m1_Testuj(st_m1_uzel moznost, int hloubka)
{
	if (hloubka <= 0) { // dokonceno
		if (moznost.tahne == moznost.ja) return m1_Symuluj(moznost.x,moznost.y,&moznost.tahne);
		else return -m1_Symuluj(moznost.x,moznost.y,&moznost.tahne);
	}

	int test[8][8]; // pro zalohu hraciho pole
	int j;
	int max; // naproste minimum je -64 (ve hre je 64 kamenu) a maximum 64

	int base;
	
	if (moznost.tahne == moznost.ja) base = m1_Symuluj(moznost.x,moznost.y,&moznost.tahne);
	else base = -m1_Symuluj(moznost.x,moznost.y,&moznost.tahne);
	if(moznost.tahne == NIC) return base;
	
	if (moznost.tahne == moznost.ja) max  = -M1_MAX;
	else max = M1_MAX; 


	memcpy(&test,&m1_test,64*sizeof(int));


	for (moznost.x = 0; moznost.x < 8; moznost.x++) // zaloha hraciho pole
		for (moznost.y = 0; moznost.y < 8; moznost.y++) {	// zaloha hraciho pole
			if(!m1_LzeTah(moznost.x,moznost.y,moznost.tahne)) continue; // aby jsme se zbytecne nezdrzovali

			if(t_kill == true) return 0;

			memcpy(&m1_test,&test,64*sizeof(int));

			j = m1_Testuj(moznost,hloubka-1);
			if(((j > max)&&(moznost.tahne == moznost.ja)) || 
				((j < max)&&(moznost.tahne != moznost.ja)))    max  = j;
		}

		if((max == -M1_MAX) || (max == M1_MAX)) max = 0;

	return base + max;
}

//******************************************************************************

int m1_Symuluj(int x, int y, int *hrac)
{
	int i = m1_UdelejTah(x,y,*hrac);

	m1_tested++;

	if(m1_Konec()) *hrac = NIC;
	else 
		//zmena hrace
		if(*hrac == HRAC_BILY){
			if(m1_MuzeHrat(HRAC_CERNY)) *hrac = HRAC_CERNY;
		}
		else {
			if(m1_MuzeHrat(HRAC_BILY)) *hrac = HRAC_BILY;
		}

	return i;
}





//******************************************************************************
bool m1_LzeTah(int x, int y, int kdo)
{
	if(m1_test[x][y] != NIC) return false;
	
	int ja,on;
	
	if(kdo == HRAC_BILY) {
		ja = BILY; on = CERNY;
	}
	else {
		ja = CERNY; on = BILY;
	}
	if (m1_LzeTahSmerem(x,y,-1,-1,ja,on)) return true;
	if (m1_LzeTahSmerem(x,y,-1, 1,ja,on)) return true;
	if (m1_LzeTahSmerem(x,y,-1, 0,ja,on)) return true;
	if (m1_LzeTahSmerem(x,y, 0,-1,ja,on)) return true;
	if (m1_LzeTahSmerem(x,y, 0, 1,ja,on)) return true;
	if (m1_LzeTahSmerem(x,y, 1,-1,ja,on)) return true;
	if (m1_LzeTahSmerem(x,y, 1, 0,ja,on)) return true;
	if (m1_LzeTahSmerem(x,y, 1, 1,ja,on)) return true;

	return false;

}
//******************************************************************************
bool m1_LzeTahSmerem(int x, int y, int dx, int dy, int ja, int on)
{
	x += dx;
	y += dy;
	if(x < 0 || y < 0 || x > 7 || y > 7) return false;
	if(m1_test[x][y] != on) return false;
	while(m1_test[x][y] != ja) {
		x += dx;
		y += dy;
		if(x < 0 || y < 0 || x > 7 || y > 7) return false;
		if(m1_test[x][y] == NIC) return false;
	}

	return true;
}

//******************************************************************************

int m1_UdelejTah(int x, int y, int ja)
{
	int on;
	
	int p = m1_body[x][y];

	if(ja == BILY) {
		on = CERNY;
		m1_test[x][y]  = BILY;
	}
	else {
		on = BILY;
		m1_test[x][y]  = CERNY;
	}

	
	m1_TahSmerem(x,y,-1,-1,ja,on,&p);
	m1_TahSmerem(x,y,-1, 1,ja,on,&p);
	m1_TahSmerem(x,y,-1, 0,ja,on,&p);
	m1_TahSmerem(x,y, 0,-1,ja,on,&p);
	m1_TahSmerem(x,y, 0, 1,ja,on,&p);
	m1_TahSmerem(x,y, 1,-1,ja,on,&p);
	m1_TahSmerem(x,y, 1, 0,ja,on,&p);
	m1_TahSmerem(x,y, 1, 1,ja,on,&p);

	return p;
}
//******************************************************************************
void m1_TahSmerem(int x, int y, int dx, int dy, int ja, int on, int *p)
{
	if(!m1_LzeTahSmerem(x,y,dx,dy,ja,on))
		return;

	x += dx;
	y += dy;
	while(m1_test[x][y] != ja) {
		(*p)++;
		m1_test[x][y]  = ja;
		x += dx;
		y += dy;
	}
}
//******************************************************************************
bool m1_MuzeHrat(int hrac)
{
	int i,j;

	for(i = 0; i < 8; i++)
		for(j = 0; j < 8; j++){
			if(m1_LzeTah(i,j,hrac )) return true;
		}

	return false;
}
//******************************************************************************
bool m1_Konec() 
{
	int i,j;

	for(i = 0; i < 8; i++)
		for(j = 0; j < 8; j++){
			if(m1_LzeTah(i,j,HRAC_BILY )) return false;
			if(m1_LzeTah(i,j,HRAC_CERNY)) return false;
		}

	return true;
}

