/*******************************************************************************/
//  Bernard Lidicky - 1999, 2000
//  Hippo Games
//  Awary
//  Modul2.cpp - Awary inteligence
/*******************************************************************************/

#include "stdafx.h"
#include "Awary.h"
#include "HraAwary.h"
#include "modul2.h"

/*
casova slozitost vypoctu 
	
*/
typedef struct {
	int  tahne; // pri zanorovani
	int  ja;    // pro vyber moznosti
	int   x;     // moznost
} st_m2_awar;


int m2_tested; // citac udelanych tahu


int   m2_test[15];
int   m2_Testuj(st_m2_awar moznost, int hloubka);
int   m2_Symuluj(int pole, int *next);
int	m2_Vysledne(int pole);

const m2_game[] = {12,11,10,9,8,7,14,5,4,3,2,1,0,14};

/*******************************************************************************/
UINT m2_t_Tahni(LPVOID p_hra){
	
	int time = timeGetTime();

	t_kill = false;
	t_hotovo = false;
	t_running = true;

	CHraAwary *h = (CHraAwary*) p_hra;
	if(h->Konec()) return 0;
	srand(h->m_rand);

	// myslici proces
	int hloubka = h->m_hrac[h->m_tahne];
/*	switch(h->m_hrac[h->m_tahne]){
		case 1 : hloubka = 1; break;
		case 2 : hloubka = 2; break;
		case 3 : hloubka = 3; break;
		case 4 : hloubka = 4; break;
		case 5 : hloubka = 5; break;
		case 6 : hloubka = 6; break;
		default : hloubka = 1;
	}
*/
	// navrat
	int i,j;
	int max  = -37; // naproste minimum je -36 (ve hre je 36 kamenu)
	int maxi = -1;
	int p;
	st_m2_awar aw;

	int hra[15];

	m2_tested = 0;

	for (j = 0; j < 14; j++) // obnova hraciho pole
		hra[j] = h->m_hra[j];

	if(h->m_tahne == HRAC_DOLE) p = 0;
	else p = 7;

	for(i = 0 + p; i < 6 + p; i++) {
		if(hra[i] == 0) continue; // aby jsme se zbytecne nezdrzovali

		for (j = 0; j < 14; j++) // obnova hraciho pole
			m2_test[j] = hra[j];

		aw.ja = h->m_tahne;
		aw.tahne = h->m_tahne;
		aw.x = i;
		j = m2_Testuj(aw,hloubka);
		if((j > max) || ((j == max) && (Nahoda(2) == 1))){
			max  = j;
			maxi = i;
		}
	}

	time = timeGetTime() - time;

	TRACE("Hloubka %d -> testovano %d tahu za %d ms\n",hloubka,m2_tested,time);

	// aby pocitac premyslel alespon 0.5 sekundy
	if(time < 500) Sleep(500 - time);

	h->Tahnul(maxi,hloubka);

	t_running = false;
	h->m_thread = NULL;
	return 0;
}

/*******************************************************************************/

int m2_Testuj(st_m2_awar moznost, int hloubka)
{
	if (hloubka <= 0) { // dokonceno
		if (moznost.tahne == moznost.ja) return m2_Vysledne(moznost.x);
		else return -m2_Vysledne(moznost.x);
	}

	int test[14]; // pro zalohu hraciho pole
	int i,j;
	int max; // naproste minimum je -36 (ve hre je 36 kamenu) a maximum 36

	int base;
	int px;
	
	if (moznost.tahne == moznost.ja) base = m2_Symuluj(moznost.x,&moznost.tahne);
	else base = -m2_Symuluj(moznost.x,&moznost.tahne);

	if (moznost.tahne == moznost.ja) {
		px   = 7;
		max  = -37;
	}
	else {
		px =  0;
		max = 37; 
	}


	for (j = 0; j < 14; j++) // zaloha hraciho pole
		test[j] = m2_test[j];


	for(i = 0 + px; i < 6 + px; i++) {
		if(test[i] == 0) continue; // aby jsme se zbytecne nezdrzovali

		for (j = 0; j < 14; j++) // obnova hraciho pole
			m2_test[j] = test[j];

		moznost.x = i;
		j = m2_Testuj(moznost,hloubka-1);
		if(((j > max)&&(moznost.tahne == moznost.ja)) || 
			((j < max)&&(moznost.tahne != moznost.ja)))    max  = j;
	}

	if((max == -37) || (max == 37)) max = 0;

	return base + max;
}

/*******************************************************************************/

int m2_Symuluj(int pole, int *next)
{
	int k = m2_test[pole];
	if(k == 0) return -1;
	int m = pole;
	
	m2_tested++;

	int dum; 
	if(m < 6) dum = 6;
	else dum = 13;

	int doma = 0;

	m2_test[pole] = 0;

	// rozhozeni
	while (k > 1) {
		m++;
		if(m > 13) m = 0;
		m2_test[m]++;
		k--;
		if(m == dum) doma++;
	}
	// posledni kamen
	m++;
	if((m2_test[m] == 0)&&(m2_test[m2_game[m]] != 0)) {
		m2_test[dum] += 1 + m2_test[m2_game[m]];
		doma += 1 + m2_test[m2_game[m]];
		m2_test[m2_game[m]] = 0;
	}
	else m2_test[m]++;
	
	//zmena hrace
	if(m != dum) 
		if(*next == HRAC_NAHORE) *next = HRAC_DOLE;
		else *next = HRAC_NAHORE;

	return doma;
}

/*******************************************************************************/

int m2_Vysledne(int pole)
{
	int k = m2_test[pole];
	if(k == 0) return -1;
	int m = pole;
	
	m2_tested++;

	int dum; 
	if(m < 6) dum = 6;
	else dum = 13;

	int doma = 0;

	m2_test[pole] = 0;

	// rozhozeni
	while (k > 1) {
		m++;
		if(m > 13) m = 0;
		m2_test[m]++;
		k--;
		if(m == dum) doma++;
	}
	// posledni kamen
	m++;
	if((m2_test[m] == 0)&&(m2_test[m2_game[m]] != 0)) {
		m2_test[dum] += 1 + m2_test[m2_game[m]];
		doma += 1 + m2_test[m2_game[m]];
		m2_test[m2_game[m]] = 0;
	}
	else m2_test[m]++;
	
	//jemny bonus
	if(m == dum) doma += 2;

	return doma;
}

